/* lmpeval.c
 *
 * Copyright (C) 1999-2000 Bernhard Pietsch <bjtp@gmx.net>
 *
 * This file is part of LMP library.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <string.h>
#include "lmp.h"

lmp_value_type lmp_eval (lmp_node_t * root) {
  lmp_value_type tmp;

  switch (root->what) {
  case OP:
    if (root->data.operation.argc == 2)
      return lmp_proc_binary (root->data.operation.op,
			      lmp_eval (root->data.operation.argv [0]),
			      lmp_eval (root->data.operation.argv [1]));
    else if (root->data.operation.argc == 1)
      return lmp_proc_unary  (root->data.operation.op,
			      lmp_eval (root->data.operation.argv [0]));
  case CONTROL:
    return lmp_eval (lmp_proc_control (root));
  case VAL:
    return root->data.value;
  case VAR:
    if (lmp_vt_lookup (root->data.variable, &tmp))
      lmp_error ("Unknown identifier `%s'.\n", root->data.variable);
    return tmp;
  }

  return 0;
}
